> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Unapply a credit memo asynchronously

PUT https://rest.test.zuora.com/v1/credit-memos/{creditMemoKey}/unapply-async
Content-Type: application/json

**Note:** This operation is only available if you have [Invoice Settlement](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement) enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information.
   Asynchronously Unapplies an applied credit memo from one or more invoices. The full applied amount from invoices is transferred into the unapplied amount of the credit memo. 

You can unapply a credit memo from an invoice only if you have the user permission. See [Billing Roles](https://knowledgecenter.zuora.com/CF_Users_and_Administrators/A_Administrator_Settings/User_Roles/d_Billing_Roles)
  When you unapply a credit memo, the total number of credit memo items and the items that credit memo items to be unapplied from must be less than or equal to 300,000.
  The maximum number of invoices that you can specify in the request is 1,000


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/billing-documents/credit-memos/unapply-credit-memo-async

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Path parameters

- `creditMemoKey` (string, required) — The unique ID or number of a credit memo. For example, 8a8082e65b27f6c3015ba45ff82c7172.

### Headers

- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.

### Body (application/json)

This endpoint expects an AsyncUnapplyCreditMemoRequest.

- `effectiveDate` (date, optional) — The date when the credit memo is unapplied.
- `invoices` (list of AsyncUnapplyCreditMemoToInvoice, optional) — Container for invoices that the credit memo is unapplied. The maximum number of invoices is 1,000.

## Response

### 200

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of InvoiceSettlementAsyncJobResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.
- `id` (string, optional) — The ID of the operation job.
- `status` (enum, optional) — Job status of the Invoice Settlement async job.
  - Allowed values: `Pending`, `Processing`, `Processed`, `Error`
- `operationType` (enum, optional) — Operation type of the Invoice Settlement async job.
  - Allowed values: `AsyncCreditMemoApply`, `AsyncCreditMemoUnapply`
- `referenceId` (string, optional) — The ID of the business object which is being operated.
- `referenceType` (enum, optional) — Reference type of the Invoice Settlement async job.
  - Allowed values: `CreditMemo`
- `error` (string, optional, nullable) — The error message if the operation error out.

## Errors

### 400 Client Request Error

Request Errors

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### AsyncUnapplyCreditMemoToInvoice

- `amount` (double, required) — The credit memo amount to be unapplied from the invoice.
- `invoiceId` (string, required) — The unique ID of the invoice that the credit memo is unapplied from.

### InvoiceSettlementAsyncJobResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

## Examples

**Request**

```json
{
  "effectiveDate": "2017-03-02",
  "invoices": [
    {
      "amount": 1,
      "invoiceId": "4028905f5a87c0ff015a87d3f8f10043"
    }
  ]
}
```

**Response**

```json
{
  "success": true,
  "id": "8a92ade496140e830196148cd0af000a",
  "status": "Pending",
  "operationType": "AsyncCreditMemoUnapply",
  "referenceId": "8a8082e65b27f6c3015ba45ff82c7172",
  "referenceType": "CreditMemo",
  "error": null
}
```

**SDK Code**

```python Credit Memos_unapplyCreditMemoAsync_example
import requests

url = "https://rest.test.zuora.com/v1/credit-memos/creditMemoKey/unapply-async"

payload = {
    "effectiveDate": "2017-03-02",
    "invoices": [
        {
            "amount": 1,
            "invoiceId": "4028905f5a87c0ff015a87d3f8f10043"
        }
    ]
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.json())
```

```javascript Credit Memos_unapplyCreditMemoAsync_example
const url = 'https://rest.test.zuora.com/v1/credit-memos/creditMemoKey/unapply-async';
const options = {
  method: 'PUT',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"effectiveDate":"2017-03-02","invoices":[{"amount":1,"invoiceId":"4028905f5a87c0ff015a87d3f8f10043"}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Credit Memos_unapplyCreditMemoAsync_example
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/credit-memos/creditMemoKey/unapply-async"

	payload := strings.NewReader("{\n  \"effectiveDate\": \"2017-03-02\",\n  \"invoices\": [\n    {\n      \"amount\": 1,\n      \"invoiceId\": \"4028905f5a87c0ff015a87d3f8f10043\"\n    }\n  ]\n}")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Credit Memos_unapplyCreditMemoAsync_example
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/credit-memos/creditMemoKey/unapply-async")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"effectiveDate\": \"2017-03-02\",\n  \"invoices\": [\n    {\n      \"amount\": 1,\n      \"invoiceId\": \"4028905f5a87c0ff015a87d3f8f10043\"\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java Credit Memos_unapplyCreditMemoAsync_example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://rest.test.zuora.com/v1/credit-memos/creditMemoKey/unapply-async")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"effectiveDate\": \"2017-03-02\",\n  \"invoices\": [\n    {\n      \"amount\": 1,\n      \"invoiceId\": \"4028905f5a87c0ff015a87d3f8f10043\"\n    }\n  ]\n}")
  .asString();
```

```php Credit Memos_unapplyCreditMemoAsync_example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://rest.test.zuora.com/v1/credit-memos/creditMemoKey/unapply-async', [
  'body' => '{
  "effectiveDate": "2017-03-02",
  "invoices": [
    {
      "amount": 1,
      "invoiceId": "4028905f5a87c0ff015a87d3f8f10043"
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Credit Memos_unapplyCreditMemoAsync_example
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/credit-memos/creditMemoKey/unapply-async");
var request = new RestRequest(Method.PUT);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"effectiveDate\": \"2017-03-02\",\n  \"invoices\": [\n    {\n      \"amount\": 1,\n      \"invoiceId\": \"4028905f5a87c0ff015a87d3f8f10043\"\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Credit Memos_unapplyCreditMemoAsync_example
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "effectiveDate": "2017-03-02",
  "invoices": [
    [
      "amount": 1,
      "invoiceId": "4028905f5a87c0ff015a87d3f8f10043"
    ]
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/credit-memos/creditMemoKey/unapply-async")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```